
#ifndef BSTRING_PRETTYNAME_H
#define BSTRING_PRETTYNAME_H


/*

FUNCTIONS you can use directly if you need them now
	but consider to declare them as unified b_ name, see below


extern int bassignmidstr (bstring a, const_bstring b, int left, int len);
extern bstring bmidstr (const_bstring b, int left, int len);
extern int bdelete (bstring s1, int pos, int len);

extern int bstrncmp (const_bstring b0, const_bstring b1, int n);
extern int bstricmp (const_bstring b0, const_bstring b1);
extern int bstrnicmp (const_bstring b0, const_bstring b1, int n);
extern int binstr (const_bstring s1, int pos, const_bstring s2);
extern int binstrr (const_bstring s1, int pos, const_bstring s2);
extern int binstrcaseless (const_bstring s1, int pos, const_bstring s2);
extern int binstrrcaseless (const_bstring s1, int pos, const_bstring s2);
extern int binchr (const_bstring b0, int pos, const_bstring b1);
extern int binchrr (const_bstring b0, int pos, const_bstring b1);
extern int bninchr (const_bstring b0, int pos, const_bstring b1);
extern int bninchrr (const_bstring b0, int pos, const_bstring b1);
extern int bstrchr (const_bstring b, int c);
extern int bstrrchr (const_bstring b, int c);
extern int bstrchrp (const_bstring b, int c, int pos);
extern int bstrrchrp (const_bstring b, int c, int pos);
extern int bsetstr (bstring b0, int pos, const_bstring b1, unsigned char fill);
extern int binsert (bstring s1, int pos, const_bstring s2, unsigned char fil
l);
int binsertblk (bstring b, int pos, const void * blk, int len, unsigned char fill);
extern int binsertch (bstring s1, int pos, int len, unsigned char fill);
extern int breplace (bstring b1, int pos, int len, const_bstring b2, unsigned char fill);
extern int bfindreplace (bstring b, const_bstring find, const_bstring replace, int position);
extern int bfindreplacecaseless (bstring b, const_bstring find, const_bstring replace, int position);

extern int bpattern (bstring b, int len);
extern int bltrimws (bstring b);
extern int brtrimws (bstring b);
extern int btrimws (bstring b);


// Split / Lists
extern struct bstrList* bstrListCreate (void);
extern int bstrListDestroy (struct bstrList * sl);
extern int bstrListAlloc (struct bstrList * sl, int msz);
extern int bstrListAllocMin (struct bstrList * sl, int msz);
extern struct bstrList * bsplit (bstring str, unsigned char splitChar);
extern struct bstrList * bsplits (bstring str, const_bstring splitStr);
extern struct bstrList * bsplitstr (bstring str, const_bstring splitStr);
extern bstring bjoin (const struct bstrList * bl, const_bstring sep);
bstring bjoinblk (const struct bstrList * bl, void * blk, int len);
extern int bsplitcb (const_bstring str, unsigned char splitChar, int pos, int (* cb) (void * parm, int ofs, int len), void * parm);
extern int bsplitscb (const_bstring str, const_bstring splitStr, int pos, int (* cb) (void * parm, int ofs, int len), void * parm);
extern int bsplitstrcb (const_bstring str, const_bstring splitStr, int pos, int (* cb) (void * parm, int ofs, int len), void * parm);

// Format functions
extern bstring bformat (const char * fmt, ...);
extern int bassignformat (bstring b, const char * fmt, ...);
extern int bvcformata (bstring b, int count, const char * fmt, va_list arglist);

// Stream functions (+ split?)
extern bstring bread (bNread readPtr, void * parm);
extern int breada (bstring b, bNread readPtr, void * parm);
extern bstring bgets (bNgetc getcPtr, void * parm, char terminator);
extern int bgetsa (bstring b, bNgetc getcPtr, void * parm, char terminator);
extern int bassigngets (bstring b, bNgetc getcPtr, void * parm, char terminator);
extern struct bStream * bsopen (bNread readPtr, void * parm);
extern void * bsclose (struct bStream * s);
extern int bsbufflength (struct bStream * s, int sz);
extern int bsreadln (bstring r, struct bStream * s, char terminator);
extern int bsreadlna (bstring r, struct bStream * s, char terminator);
extern int bsreadlns (bstring r, struct bStream * s, bstring terminators);
extern int bsreadlnsa (bstring r, struct bStream * s, bstring terminators);
extern int bsread (bstring r, struct bStream * s, int n);
extern int bsreada (bstring r, struct bStream * s, int n);
extern int bsunread (struct bStream * s, const_bstring b);
extern int bspeek (bstring r, const struct bStream * s);

extern int bssplitscb (struct bStream * s, const_bstring splitStr, int (* cb) (void * parm, int ofs, const_bstring entry), void * parm);
extern int bssplitstrcb (struct bStream * s, const_bstring splitStr, int (* cb) (void * parm, int ofs, const_bstring entry), void * parm);
extern int bseof (const struct bStream * s);


MACROS you can use if you really need them

int blength (const_bstring b);
int blengthe (const_bstring b, int err);
char bchar (const_bstring b, int p);
int bchare (const_bstring b, int p, int c);

char * bdata (bstring b);
char * bdatae (bstring b, char * err);

char * bdataofs (bstring b, int ofs);
char * bdataofse (bstring b, int ofs, char * err);



void btfromblkltrimws (struct tagbstring& t, void * s, int len);
void btfromblkrtrimws (struct tagbstring& t, void * s, int len);
void btfromblktrimws (struct tagbstring& t, void * s, int len);


int binsertStatic (bstring s1, int pos, " ... ", char fill);
int bassignStatic (bstring b, " ... ");
bstring bjoinStatic (const struct bstrList * bl, " ... ");
void bvformata (int& ret, bstring b, const char * format, lastarg);
void bwriteprotect (struct tagbstring& t);
void bwriteallow (struct tagbstring& t);

f
*/


// Datentypen
// char     char
// c        char* = cstring
// c*Static const char* = static cstring
// k        void* + len = block
// b        bstring = tagbstring*
// s        tagbstring = *bstring



// Allocate complete new bstring
#define b_bnew(trash)             prettyname_new // bstring str = b_bnew(.)
#define b_bfromb(b)               bstrcpy(b)
#define b_bfromc_Static(c)        bfromStatic(c)
#define b_bfromc(c)               bfromcstr(c)
#define b_bfromc_Min(c, m)        bfromcstralloc(m, c)
#define b_bfromc_MinMax(c,m,a)    bfromcstrrangealloc(m, a, c)
#define b_bfromk(k, L)            blk2bstr(k, L)
#define b_bfromr(ch)              blk2bstr(&(ch), 1)
#define b_bfroms(s)               bstrcpy(&(s))

// Manage bstring
#define b_bsane(b)                (((b) == (void *)0 || (b)->slen < 0) ? 0 : 1)
#define b_blength(b)              blength(b)
#define b_blengthorerr(b, e)      blengthe(b, -1)
#define b_bmemlength              (((b) == (void *)0) ? 0 : ((b)->mlen))
#define b_bmemgrow(b, N)          balloc(b, N) // grow
#define b_bmemshrink_Try          ballocmin // grow/shrink, but keep data

// Destroy bstring
#define b_bdestroy(b)             bdestroy(b)
#define b_sdestroy(s)             prettyname_sdestroy(s)



// Return a ro tagbstring referencing a C string / block.
#define b_snew(trash)             prettyname_btfromcstr((void *)0)
#define b_sfromc_Ref(c)           prettyname_btfromcstr(c)
#define b_sfromc_StaticRef(c)     prettyname_btfromcstr_static(c)
#define b_sfromk_Ref(k, L)        prettyname_btfromblk(k, L)
#define b_sfromb                  No help from me. Be careful!

// Manage tagbstring
#define b_sro(s)                  biswriteprotected(s)
#define b_ssetro(s)               bwriteprotect(s)
#define b_ssetrw(s)               bwriteallow(s)

// Manage cstring
#define b_cfromb_CopyRepl_(b)     bstr2cstr(b, '_')
#define b_cfromb_CopyRepl(b,repl) bstr2cstr(b, repl)
#define b_cfree(c)                bcstrfree(c)

// Manage char
#define b_ratb(b, P)              bchar( (b), (P))
#define b_ratb_unsave(b, P)       (b->data[P])
#define b_rats(s, P)              bchar(&(s), (P))


// Compare strings

#define b_bcmpb                   bstrcmp


#define b_beqb                    biseq
#define b_beqc                    biseqcstr
#define b_beqc_Static             biseqStatic
#define b_beqk                    biseqblk
#define b_beqs(b, s2)             biseq(b, &(s2))

#define b_seqb(s, b2)             biseq(&(s), b2)
#define b_seqc(s, c)              biseqcstr(&(s), c)
#define b_seqc_Static(s, c)       biseqStatic(&(s), c)
#define b_seqk(s, k, L)           biseqblk(&(s), k, L)
#define b_seqs(s, s2)             biseq(&(s), &(s2))

#define b_bstartswithc_Static     bisstemeqStatic
#define b_bstartswithk(b, k, L)   bisstemeqblk(b, k, L)



// Work on strings
#define b_bassingb(b, b2)         bassign(b, b2)
#define b_bassingc(b, c)          bassigncstr(b, c)
#define b_bassingk(b, k, L)       bassignblk(b, k, L)
#define b_bassings(b, s)          bassign(b, &(s))



#define b_bcatb(b, b2)            bconcat(b, b2)
	// TODO: performance-version of b_bcatb which directly uses b2 data when empty. (for print command)
#define b_bcatc(b, c)             bcatcstr(b, c)
#define b_bcatc_Static(b, c)      bcatStatic(b, c)
#define b_bcatk(b, k, L)          bcatblk(b, k, L)
#define b_bcatr(b, ch)            bconchar(b, ch)
#define b_bcats(b, s)             bconcat(b, &(s))


#define b_bcatcformat             bformata


#define b_btoupper                btoupper
#define b_btolower                btolower

// Need this??
//#define b_fillsfrombmid(s,b,P,L)  bmid2tbstr(s,b,P,L)



#define b_btrunc                  btrunc // no memory operation

#define b_writeb                  prettyname_writeb
#define b_writes                  prettyname_writes





#include <unistd.h> // write

static inline ssize_t prettyname_writeb(int fd, struct tagbstring* b) {
	return write (fd, b->data, b->slen);
}

static inline ssize_t prettyname_writes(int fd, struct tagbstring b) {
	return write (fd, b.data, b.slen);
}
#define b_writek                  write


// Taken from bstrlib.c
static int prettyname_sdestroy (struct tagbstring s) {
	if (s.slen < 0 || s.mlen <= 0 || s.mlen < s.slen ||
	    s.data == NULL)
		return BSTR_ERR;

	// TODO: cann't use bstr__free, so include sdestroy in the 2015 library!
	free (s.data);

	/* In case there is any stale usage, there is one more chance to
	   notice this error. */

	s.slen = -1;
	s.mlen = -__LINE__;
	s.data = NULL;

	return BSTR_OK;
}




/* Own, custom functions (longname) */

#define prettyname_new b_bfromk((void*)274, 0) // Cannot say NULL here because of bstrlib internals

// Like btfromblk, btfromcstr
// One could make a function out of it, couldn't one? (For <C99 - https://stackoverflow.com/a/43890427)
#define prettyname_btfromcstr(s) prettyname_btfromblk(s, (!s) ? 0 : (int) (strlen) (s))

#define prettyname_btfromblk(k, l) (struct tagbstring) { \
	.data = (unsigned char*) (k), \
	.slen = l, \
	.mlen = -2, } // -2 = probably unfreeable, unwriteallowable


#define prettyname_btfromcstr_static(s) (struct tagbstring) bsStaticMlen(s, -2)



#endif // #ifndef BSTRING_PRETTYNAME_H

